package com.eactive.eai.batch.job.jobItem.insure;

import com.eactive.eai.common.exception.ExceptionUtil;

import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;

public class RECV_INSBT_0810 extends DefaultTelegram implements TelegramService
{
    //>> 거래구분코드 정의
    // 업무개시
    private final String TrClass_start      = "061000";
    private final String TrClass_end        = "063000";

    /**
     * 생성자
     */
    public RECV_INSBT_0810() {
    }

    /**
     * 전문 해체하기
     */
    public boolean doExecute() {
        if (!super.doExecute()) return false;

        if (this.getTrClass().equalsIgnoreCase(this.TrClass_start)) {
            logger.info("{} BATCH JOB : START request received", logHeader);
        } else if (this.getTrClass().equalsIgnoreCase(this.TrClass_end)) {
            logger.info("{} BATCH JOB : END request received", logHeader);
        } else {
            logger.info("{} 0810 telegram : unknown trasaction classification code received >> "+this.getTrClass(), logHeader);
            String errMsg = ExceptionUtil.getErrorCode ("BECEAIFJI015", new String[] { this.batchDoc.getBatchMsg().getHeader().getProcessCode(), this.getTrClass() });
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
        }

        // 응답코드에 대한 처리는 RULE 로 처리됨.
        return true;
    }

    /**
     * 전문 Validation
     */
    public boolean doValidation()
    {
        if (!super.doValidation()) return false;

		//요구전문의 응답전문에 대한 Validation 실패시 요구송신 Process 종료 (return false)
		//(전문헤더 Validation은 RECV_T_RTMPS 클래스에서 수행되어 응답코드가 설정됨)
		if (!super.getResolveResponseCode().equals(TelegramKeys.RPS_HDB_RET_CODE_SUCCESS)) return false;

        return true;
    }

    /**
     * doPostExecute
     */
    public boolean doPostExecute() {
        try {
            if (!super.doPostExecute()) return false;
            /////////////////////////////////////////////////////////////
            /////////////////////////////////////////////////////////////
            logger.info("{}  doPostExecute called", logHeader);
            return true;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    /**
     * 비정형 필드에 대한 수신길이 계산
     */
    public int getCalculatedLength(int idx) {
        logger.info("{} getCalculatedLength unexpectedly called : idx = " + idx, logHeader);
        return 0;
    }
    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
		return super.getFieldValueString(7);
    }
    // 거래구분코드 필드값 리턴
    public String getTrClass()
    {
		return super.getFieldValueString(8);
    }
    //응답코드 필드값 리턴
    public String getResCode()
    {
		return super.getFieldValueString(11);
    }
	
}
